//Peter Greczner, PC

module ProgramCounter(clock, enabled, PC_out, PC_in, reset, isDraw, isDrawDone);

input wire clock;
input wire enabled;
input wire reset;
input wire isDraw, isDrawDone;
input wire [11:0] PC_in;
output reg [11:0] PC_out;

always @ (posedge clock, posedge reset)
begin
    if(reset)
    begin
        PC_out <= 12'b0;
    end
    else if(enabled & ~(isDraw & isDrawDone)) begin
        PC_out <= PC_in;
    end
end

endmodule
