%Peter Greczner
%Sending commands to serial

delete(INSTRFIND)
porta_ser = serial('COM1');
porta_ser.BaudRate = 115200;
porta_ser.DataBits = 8;
porta_ser.Parity = 'none';
porta_ser.StopBits = 1;
porta_ser.FlowControl = 'none';
porta_ser.Terminator ='CR';
fopen(porta_ser);

CIRCLE_FILL = 0;
CIRCLE_DRAW = 1;
SQUARE_FILL = 2;
SQUARE_DRAW = 3;
LINE_DRAW = 4;




instruction = SQUARE_DRAW;
color = (4)*16*16 + (2)*16 + (15);
xstart = 70;
ystart = 150;
xend_width = 40;
yend_height = 100;
extra1 = 0;
extra2 = 0;

instruction_bits = dec2bin(instruction,6);
color_bits = dec2bin(color,12);
xstart_bits = dec2bin(xstart,10);
ystart_bits = dec2bin(ystart,9);
xend_width_bits = dec2bin(xend_width,10);
yend_height_bits = dec2bin(yend_height,9);
extra1_bits = dec2bin(extra1,8);
extra2_bits = dec2bin(extra2,8);


byte1 = bin2dec([instruction_bits, color_bits(1:2)]);
byte2 = bin2dec(color_bits(3:10));
byte3 = bin2dec([color_bits(11:12), xstart_bits(1:6)]);
byte4 = bin2dec([xstart_bits(7:10), ystart_bits(1:4)]);
byte5 = bin2dec([ystart_bits(5:9), xend_width_bits(1:3)]);
byte6 = bin2dec([xend_width_bits(4:10), yend_height_bits(1)]);
byte7 = bin2dec([yend_height_bits(2:9)]);
byte8 = bin2dec(extra1_bits);
byte9 = bin2dec(extra2_bits);
byte10 = bitxor(byte1, bitxor(byte2, bitxor(byte3, bitxor(byte4, bitxor(byte5, bitxor(byte6, bitxor(byte7, bitxor(byte8,byte9))))))));

packet = [byte1, byte2, byte3, byte4, byte5, byte6, byte7, byte8, byte9, byte10];
for i = 1:10
    fwrite(porta_ser, char(packet(i)), 'uchar');
end

packet'
