module idle_refresh(VGA_SYNC, VGA_CLK, Coord_X, Coord_Y,
									we, addr_reg, data_reg, reset,
									my_id,
									id_req);
									

input wire VGA_SYNC;
input wire VGA_CLK;
input wire [9:0] Coord_X, Coord_Y;
output reg we; // we for SRAM
output reg [17:0] addr_reg; //memory address register for SRAM
output reg [15:0] data_reg; //memory data register  for SRAM
input wire reset;
input wire [3:0] my_id, id_req;


always @ (posedge VGA_CLK) begin
	if(reset) begin
		//clear the screen
		addr_reg <= {Coord_X[9:1],Coord_Y[9:1]} ;	// [17:0]
		we <= 1'b0;								//write some memory
		data_reg <= 16'b0;						//write all zeros (black)
		
	end
	else if (VGA_SYNC) begin
		
	end
	else
	begin
		addr_reg <= {Coord_X[9:1],Coord_Y[9:1]} ;
		we <= 1'b1;
	end
end



endmodule
