%send instruction

function sendInstruction(instr)
global PORT;

instruction_bits = dec2bin(instr(1),6);
color_bits = dec2bin(instr(2),12);
xstart_bits = dec2bin(instr(3),10);
ystart_bits = dec2bin(instr(4),9);
xend_width_bits = dec2bin(instr(5),10);
yend_height_bits = dec2bin(instr(6),9);
extra1_bits = dec2bin(instr(7),8);
extra2_bits = dec2bin(instr(8),8);


byte1 = bin2dec([instruction_bits, color_bits(1:2)]);
byte2 = bin2dec(color_bits(3:10));
byte3 = bin2dec([color_bits(11:12), xstart_bits(1:6)]);
byte4 = bin2dec([xstart_bits(7:10), ystart_bits(1:4)]);
byte5 = bin2dec([ystart_bits(5:9), xend_width_bits(1:3)]);
byte6 = bin2dec([xend_width_bits(4:10), yend_height_bits(1)]);
byte7 = bin2dec([yend_height_bits(2:9)]);
byte8 = bin2dec(extra1_bits);
byte9 = bin2dec(extra2_bits);
byte10 = bitxor(byte1, bitxor(byte2, bitxor(byte3, bitxor(byte4, bitxor(byte5, bitxor(byte6, bitxor(byte7, bitxor(byte8,byte9))))))));

packet = [byte1, byte2, byte3, byte4, byte5, byte6, byte7, byte8, byte9, byte10];
for i = 1:10
    fwrite(PORT, char(packet(i)), 'uchar');
end

fread(PORT,1)

end